#ifndef CUSTOM_FIGURES_H
#define CUSTOM_FIGURES_H

#include "util.h"
#include "swarm.h"
#include <memory>

class Pyramid : public Figure
{
  protected:
    std::shared_ptr<Figure> getFigurePointer();
  public:
    std::shared_ptr<Pyramid> clone() const;
    Pyramid();
};

class FishTank : public Figure
{
  bool swarmFits(const Swarm& swarm) const;
  bool sharkFits(const Shark& shark) const;
  protected:
    std::shared_ptr<Figure> getFigurePointer();
  public:
    FishTank(const Swarm& swarm, const Shark& shark);
};

class Plant : public Figure
{
  protected:
    std::shared_ptr<Figure> getFigurePointer();
  public:
    Plant(const char* filename, int width, int height);
};

#endif
